<?php
/*
Plugin Name: Movie-List Player widget
Plugin URI: http://www.movie-list.com/ml-player/
Description: Adds a sidebar widget to show the Movie-List Player.
Author: JP Bazinet
Version: 1.2
Author URI: http://www.movie-list.com
*/

// _Very_ largely based on the gsearch widget by Automattic
// Currently weekly doesn't work


// Put functions into one big function we'll call at the plugins_loaded
// action. This ensures that all required plugin functions are defined.
function widget_mlplayer_init() {

	// Check for the required plugin functions. This will prevent fatal
	// errors occurring when you deactivate the dynamic-sidebar plugin.
	if ( !function_exists('register_sidebar_widget') )
		return;

	// This is the function that outputs our little Google search form.
	function widget_mlplayer($args) {
		
		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);
		
		
		
		
		$widget = <<<YTB
<script type="text/javascript" src="http://www.movie-list.com/ml-player/swfobject.js"></script>
<span id="player"><a href="http://www.macromedia.com/go/getflashplayer">Get Flash</a> to see this player.</span>
<script id="mlPlayerScript" src="http://www.movie-list.com/ml-player/ml-player.js?width=%width%&height=%height%&random=%random%&autostart=%autostart%" type="text/javascript"></script>
YTB;
		
		// Each widget can store its own options. We keep strings here.
		$options = get_option('widget_mlplayer');
		$width = $options['width'];
		$height = $options['height'];
		$title = ($options['title'] != "") ? $before_title.$options['title'].$after_title : "";  // ($options['title'] != "") ? $options['title'] : "Compete Rankings";
		$random = ($options['random'] == '1') ? 'true' : 'false';
		$autostart = ($options['autostart'] == '1') ? 'true' : 'false';
		
		// These lines generate our output. Widgets can be very complex
		// but as you can see here, they can also be very, very simple.
		//echo $before_widget . $before_title . $title . $after_title;
		
		$content = str_replace(
			array(
				"%width%",
				"%height%",
				"%random%",
				"%autostart%"
			), 
			array(
				$width,
				$height,
				$random,
				$autostart
			), 
			$widget
		);
		
		echo $before_widget;
		echo $title;
		echo $content;
		echo $after_widget;
	
	}

	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_mlplayer_control() {

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_mlplayer');
		if ( !is_array($options) )
			$options = array('title'=>'', 
				'width' => '320',
				'height' => '240',
				'random' => '0',
				'autostart' => '0'
			);
		if ( $_POST['mlplayer-submit'] ) {

			// Remember to sanitize and format use input appropriately.
			$options['title'] = strip_tags(stripslashes($_POST['mlplayer-title']));
			$options['width'] = strip_tags(stripslashes($_POST['mlplayer-width']));
			$options['height'] = strip_tags(stripslashes($_POST['mlplayer-height']));
			$options['random'] = ($_POST['mlplayer-random'] == "on" ) ? "1" : "0";
			$options['autostart'] = ($_POST['mlplayer-autostart'] == "on" ) ? "1" : "0";
			
			update_option('widget_mlplayer', $options);
		}

		// Be sure you format your options to be valid HTML attributes.
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$width = htmlspecialchars($options['width'], ENT_QUOTES);
		$height = htmlspecialchars($options['height'], ENT_QUOTES);
		$random = htmlspecialchars($options['random'], ENT_QUOTES);
		$autostart = htmlspecialchars($options['autostart'], ENT_QUOTES);
		
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align:right;"><label for="mlplayer-title">' . __('Title:') . ' <input style="width: 200px;" id="mlplayer-title" name="mlplayer-title" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="mlplayer-width">' . __('Width:', 'widgets') . ' <input style="width: 200px;" id="mlplayer-width" name="mlplayer-width" type="text" value="'.$width.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="mlplayer-height">' . __('Height:', 'widgets') . ' <input style="width: 200px;" id="mlplayer-height" name="mlplayer-height" type="text" value="'.$height.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="mlplayer-random">' . __('Random:', 'widgets') . ' <input id="mlplayer-random" name="mlplayer-random" type="checkbox" ' . (  ($random == '1') ? "checked=\"checked\"" : "" ) . '</label></p>';
		echo '<p style="text-align:right;"><label for="mlplayer-autostart">' . __('Autostart:', 'widgets') . ' <input id="mlplayer-autostart" name="mlplayer-autostart" type="checkbox" ' . (  ($autostart == '1') ? "checked=\"checked\"" : "" ) . '</label></p>';
		//echo '<p style="text-align:right;"><label for="compete-imagesize">' . __('Image Size:','widgets') . ' <select style="width: 200px;" id="compete-imagesize" name="compete-imagesize"><option value="large" ' . ( ($imagesize == "large") ? "selected=\"selected\"" : "" ) . '>Large</option><option value="small" ' . ( ($iamgesize == "small") ? "selected=\"selected\"" : "") . '>Small</option></select></label></p>';
		//echo '<p style="text-align:right;"><label for="compete-content">' . __('Widget Format:', 'widgets') . ' <textarea style="width: 200px;" id="compete-content" name="compete-content" row="5" cols="20">'.$content.'</textarea></label></p>';
		echo '<input type="hidden" id="mlplayer-submit" name="mlplayer-submit" value="1" />';
	}
	
	// This registers our widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('ML Player', 'widgets'), 'widget_mlplayer');

	// This registers our optional widget control form. Because of this
	// our widget will have a button that reveals a 300x100 pixel form.
	register_widget_control(array('ML Player', 'widgets'), 'widget_mlplayer_control', 300, 200);
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_mlplayer_init');

?>